/*============================================================================
//	apci34s.h
//
//	aPCI-P34
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	̿ɂׯ߰֐̎gpႪLqĂ܂B
//
//==========================================================================*/
#pragma once

#include <windows.h>
#include "Apci34w.h"

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;

namespace SampleP34
{
	/// <summary> 
	/// Apci34s ̊Tv
	///
	/// x : ̃NX̖OύXꍇÃNXˑ邷ׂĂ .resx t@CɊ֘Atꂽ 
	///          }l[W \[X RpC c[ɑ΂ 'Resource File Name' vpeB 
	///          ύXKv܂B̕ύXsȂƁA
	///          fUCiƁÃtH[Ɋ֘Atꂽ[JCYς݃\[XƂA
	///          ݂ɗpłȂȂ܂B
	/// </summary>
	public __gc class Apci34s : public System::Windows::Forms::Form
	{
	public: 
		Apci34s(void)
		{
			InitializeComponent();
		}
        
	protected: 
		void Dispose(Boolean disposing)
		{
			if (disposing && components)
			{
				components->Dispose();
			}
			__super::Dispose(disposing);
		}
        
	private:
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		System::ComponentModel::Container* components;

		static Apci34w* P34w;

		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		void InitializeComponent(void)
		{
			// 
			// Apci34s
			// 
			this->AutoScaleBaseSize = System::Drawing::Size(5, 12);
			this->ClientSize = System::Drawing::Size(292, 273);
			this->Name = S"Apci34s";
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
			this->Text = S"aPCI-P34 Sample";
			this->Load += new System::EventHandler(this, Apci34s_Load);

		}		
		private: System::Void Apci34s_Load(System::Object *  sender, System::EventArgs *  e)
		{
			short wLogSlot;			// ޲̘_ۯĔԍi[
			Apci34w::Resource* Ri;	// ؿ
			Apci34w::Mode* Md;
			int dwDllVer, dwDrvVer;
			int dwSwVal;			// ۰ذ̒l
			int i;
			Byte cbDat;
			bool bResult;			// 
			String* szBuf;

			// 
			P34w = new Apci34w();
			Md   = new Apci34w::Mode;
			Ri   = new Apci34w::Resource;
			Ri->dwMemBase		= new Int32[Apci34w::MAX_MEM];
			Ri->dwMemLength		= new Int32[Apci34w::MAX_MEM];
			Ri->dwMemAttrib		= new Int32[Apci34w::MAX_MEM];
			Ri->dwIOPortBase	= new Int32[Apci34w::MAX_IO];
			Ri->dwIOPortLength	= new Int32[Apci34w::MAX_IO];
			Ri->dwIRQRegisters	= new Int32[Apci34w::MAX_IRQ];
			Ri->dwIRQAttrib		= new Int32[Apci34w::MAX_IRQ];
			Ri->dwDMALst		= new Int32[Apci34w::MAX_DMA];
			Ri->dwDMAAttrib		= new Int32[Apci34w::MAX_DMA];
			Ri->dwReserved1		= new Int32[Apci34w::MAX_RSV];
			Ri->dwNumMemWindows = 0;
			for (i=0; i<Apci34w::MAX_MEM; i++) {
				Ri->dwMemBase[i]	 = 0;
				Ri->dwMemLength[i] = 0;
				Ri->dwMemAttrib[i] = 0;
			}
			Ri->dwNumIOPorts = 0;
			for (i=0; i<Apci34w::MAX_IO; i++) {
				Ri->dwIOPortBase[i]   = 0;
				Ri->dwIOPortLength[i] = 0;
			}
			Ri->dwNumIRQs = 0;
			for (i=0; i<Apci34w::MAX_IRQ; i++) {
				Ri->dwIRQRegisters[i] = 0;
				Ri->dwIRQAttrib[i]	= 0;
			}
			Ri->dwNumDMAs = 0;
			for (i=0; i<Apci34w::MAX_DMA; i++) {
				Ri->dwDMALst[i]	 = 0;
				Ri->dwDMAAttrib[i] = 0;
			}
			for (i=0; i<Apci34w::MAX_RSV; i++)
				Ri->dwReserved1[i] = 0;

			/*-----------------------------------------------------------------------*/
			// ްޮݔԍ\
			// aPCI-34 DLL,ײްްޮݔԍ擾
			if (P34w->GetVersion(&dwDllVer, &dwDrvVer) == false) {
				ErrorMessage(Apci34w::SLOT_AUTO);
				return;
			}
			szBuf = String::Concat(S"GetVersion\n",
									String::Format(S"DLL Version\t: {0}\n", 
													dwDllVer.ToString("x8")),
									String::Format(S"DRV Version\t: {0}",
													dwDrvVer.ToString("x8")));
			ResultMessage(szBuf);

			/*-----------------------------------------------------------------------*/
			// aPCI-34̎gp錾
			wLogSlot = Apci34w::SLOT_AUTO;	// gp޲T܂
			bResult = P34w->Create(&wLogSlot, NULL, 0, NULL);	// ꍇA̎޲̘_ۯĔԍi[܂
			if (bResult == false) {			// ޲܂B
				ErrorMessage(Apci34w::SLOT_AUTO);
				return;
			}
			szBuf = String::Concat(S"Created\n\n",
									String::Format(S"LogSlot: {0}", 
													wLogSlot.ToString()));
			ResultMessage(szBuf);

			/*-----------------------------------------------------------------------*/
			// ؿ۰ذ̒l擾
			if (P34w->GetResource(wLogSlot, Ri) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			if (P34w->GetSwitchValue(wLogSlot, &dwSwVal) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			szBuf = String::Concat(String::Format(S"IO Base Address  \t: {0}h - {1}h\n",
													Ri->dwIOPortBase[1].ToString("x4"),
													(Ri->dwIOPortBase[1] + Ri->dwIOPortLength[1] - 1).ToString("x4")),
									String::Format(S"IRQ         \t\t: {0}\n",
													(Ri->dwIRQRegisters[0]).ToString()),
									String::Format(S"Switch      \t: {0}h",
													dwSwVal.ToString("x")));
			ResultMessage(szBuf);

			/*-----------------------------------------------------------------------*/
			// IN01/IN02/IN09/IN10 ̊荞ݐݒ
			Md->dwIn01 = Apci34w::IRQ_DISABLE;			// 荞݋֎~
			Md->dwIn02 = Apci34w::IRQ_DISABLE;			// 荞݋֎~
			Md->dwIn09 = Apci34w::IRQ_DISABLE;			// 荞݋֎~
			Md->dwIn10 = Apci34w::IRQ_DISABLE;			// 荞݋֎~
			if (P34w->IrqMode(wLogSlot, Md) == false) {
				ErrorMessage(wLogSlot);
				return;
			}

			/*-----------------------------------------------------------------------*/
			// Port 1 ɔCӂްo
			cbDat = 0x55;
			if (P34w->OutPort(wLogSlot, Apci34w::PORT_1, cbDat) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			szBuf = String::Concat(S"Port 1 փf[^o\n",
									String::Format(S"Port 1 Out Data: {0}h", cbDat.ToString("x2")));
			ResultMessage(szBuf);

			/*-----------------------------------------------------------------------*/
			// Port 1 ްǂݍ
			cbDat = 0x00;
			if (P34w->InPort(wLogSlot, Apci34w::PORT_1, &cbDat) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			szBuf = String::Concat(S"Port 1 f[^\n",
									String::Format(S"Port 1 In Data: {0}h", cbDat.ToString("x2")));
			ResultMessage(szBuf);

			/*-----------------------------------------------------------------------*/
			// IN01/IN02/IN09/IN10 ̊荞ݐݒ
			//Md->dwIn01 = Apci34w::IRQ_DISABLE;			// 荞݋֎~
			//Md->dwIn02 = Apci34w::IRQ_DISABLE;			// 荞݋֎~
			//Md->dwIn09 = Apci34w::IRQ_DISABLE;			// 荞݋֎~
			//Md->dwIn10 = Apci34w::IRQ_DISABLE;			// 荞݋֎~
			//if (P34w->IrqMode(wLogSlot, Md) == false) {
			//	ErrorMessage(wLogSlot);
			//	return;
			//}

			/*-----------------------------------------------------------------------*/
			// aPCI-34̎gpJ
			if (P34w->Close(wLogSlot) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			ResultMessage(S"Closed");
			this->Close();
		}

		// ʂ\
		private: void ResultMessage(String* pszbuf)
		{
			MessageBox::Show(pszbuf, this->Text,
								MessageBoxButtons::OK, MessageBoxIcon::Information);
		}

		// װүނ\
		private: void ErrorMessage(short wLogSlot)
		{
			int dwRes = P34w->GetLastError(wLogSlot);
			String* szbuf;

			switch (dwRes) {
			 	case Apci34w::ERR_WRAPDLL:
			 	case Apci34w::ERR_SYSTEM:
					dwRes = System::Runtime::InteropServices::Marshal::GetLastWin32Error();
					szbuf = String::Concat(S"System error\n\n",
											String::Format(S"Error code: {0}h", dwRes.ToString("x8")));
					break;
				default:
					szbuf = String::Concat(S"aPCI-P34 error\n\n",
											String::Format(S"Error code: {0}h", dwRes.ToString("x8")));
					break;
			}
			MessageBox::Show(szbuf, S"aPCI-P34 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Stop);
		}
	};
}
