'============================================================================
'
'  aPCI-P34
'
'  Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'
'   ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
'
'============================================================================
Option Strict Off
Option Explicit On

Imports System.Runtime.InteropServices

Public Class Apci34s

    Dim P34w As Apci34w

    Private Sub Apci34s_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim Md As Apci34w.Mode
        Dim Ri As Apci34w.Resource  ' ؿ
        Dim wLogSlot As Short       ' ޲̘_ۯĔԍi[
        Dim dwDllVer As Integer, dwDrvVer As Integer
        Dim i As Integer
        Dim dwSwVal As Integer      ' ۰ذ̒l
        Dim cbDat As Byte
        Dim bResult As Boolean      ' 
        Dim szBuf As String

        ' 
        P34w = New Apci34w
        Md = New Apci34w.Mode
        Ri = New Apci34w.Resource
        Ri.dwMemBase = New Integer(Apci34w.MAX_MEM) {}
        Ri.dwMemLength = New Integer(Apci34w.MAX_MEM) {}
        Ri.dwMemAttrib = New Integer(Apci34w.MAX_MEM) {}
        Ri.dwIOPortBase = New Integer(Apci34w.MAX_IO) {}
        Ri.dwIOPortLength = New Integer(Apci34w.MAX_IO) {}
        Ri.dwIRQRegisters = New Integer(Apci34w.MAX_IRQ) {}
        Ri.dwIRQAttrib = New Integer(Apci34w.MAX_IRQ) {}
        Ri.dwDMALst = New Integer(Apci34w.MAX_DMA) {}
        Ri.dwDMAAttrib = New Integer(Apci34w.MAX_DMA) {}
        Ri.dwReserved1 = New Integer(Apci34w.MAX_RSV) {}
        Ri.dwNumMemWindows = 0
        For i = 0 To Apci34w.MAX_MEM
            Ri.dwMemBase(i) = 0
            Ri.dwMemLength(i) = 0
            Ri.dwMemAttrib(i) = 0
        Next
        Ri.dwNumIOPorts = 0
        For i = 0 To Apci34w.MAX_IO
            Ri.dwIOPortBase(i) = 0
            Ri.dwIOPortLength(i) = 0
        Next
        Ri.dwNumIRQs = 0
        For i = 0 To Apci34w.MAX_IRQ
            Ri.dwIRQRegisters(i) = 0
            Ri.dwIRQAttrib(i) = 0
        Next
        Ri.dwNumDMAs = 0
        For i = 0 To Apci34w.MAX_DMA
            Ri.dwDMALst(i) = 0
            Ri.dwDMAAttrib(i) = 0
        Next
        For i = 0 To Apci34w.MAX_RSV
            Ri.dwReserved1(i) = 0
        Next

        '-------------------------------------------------
        ' ްޮݔԍ\
        ' aPCI-P34 DLL,ײްްޮݔԍ擾
        '-------------------------------------------------
        If P34w.GetVersion(dwDllVer, dwDrvVer) = False Then
            ErrorMessage(Apci34w.SLOT_AUTO)
            Exit Sub
        End If
        szBuf = String.Concat("GetVersion", vbCrLf, _
                                String.Format("DLL Version: &H{0:x8}", dwDllVer), vbCrLf, _
                                String.Format("Drv Version: &H{0:x8}", dwDrvVer))
        ResultMessage(szBuf)
        '-------------------------------------------------
        ' aPCI-P34̎gp錾
        '-------------------------------------------------
        wLogSlot = Apci34w.SLOT_AUTO                ' gp޲T܂B
        bResult = P34w.Create(wLogSlot, 0, 0, 0)    ' ꍇA̎޲̘_ۯĔԍi[܂B
        If bResult = False Then                     ' ޲܂B
            ErrorMessage(Apci34w.SLOT_AUTO)
            Exit Sub
        End If

        szBuf = String.Concat("Created", vbCrLf, vbCrLf, _
                                String.Format("LogSlot: {0:d}", wLogSlot))
        ResultMessage(szBuf)
        '-------------------------------------------------
        ' ؿ۰ذ̒l擾
        '-------------------------------------------------
        If P34w.GetResource(wLogSlot, Ri) = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If
        If P34w.GetSwitchValue(wLogSlot, dwSwVal) = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If
        szBuf = String.Concat(String.Format("IO Address: &H{0:x4} - &H{1:x4}", _
                                                    Ri.dwIOPortBase(1), _
                                                    Ri.dwIOPortBase(1) + Ri.dwIOPortLength(1) - 1), _
                                                    vbCrLf, _
                                String.Format("IRQ: {0:d}", Ri.dwIRQRegisters(0)), vbCrLf, _
                                String.Format("Switch: &H{0:x}", dwSwVal))
        ResultMessage(szBuf)
        '-------------------------------------------------
        ' IN01/IN02/IN09/IN10 ̊荞ݐݒ
        '-------------------------------------------------
        Md.dwIn01 = Apci34w.IRQ_DISABLE     ' 荞݋֎~
        Md.dwIn02 = Apci34w.IRQ_DISABLE     ' 荞݋֎~
        Md.dwIn09 = Apci34w.IRQ_DISABLE     ' 荞݋֎~
        Md.dwIn10 = Apci34w.IRQ_DISABLE     ' 荞݋֎~
        If P34w.IrqMode(wLogSlot, Md) = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If
        '-------------------------------------------------
        ' Port 1 ɔCӂްo
        '-------------------------------------------------
        cbDat = &H55
        If P34w.OutPort(wLogSlot, Apci34w.PORT_1, cbDat) = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If

        szBuf = String.Concat("Port 1 փf[^o", vbCrLf, _
                                String.Format("Port 1 Out Data: &H{0:x2}", cbDat))
        ResultMessage(szBuf)
        '-------------------------------------------------
        ' Port 1 f[^ǂݍ
        '-------------------------------------------------
        cbDat = &H0
        If P34w.InPort(wLogSlot, Apci34w.PORT_1, cbDat) = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If
        szBuf = String.Concat("Port 1 f[^", vbCrLf, _
                                String.Format("Port 1 In Data: &H{0:x2}", cbDat))
        ResultMessage(szBuf)
        '-------------------------------------------------
        ' IN01/IN02/IN09/IN10 ̊荞ݐݒ
        '-------------------------------------------------
        'Md.dwIn01 = Apci34w.IRQ_DISABLE     ' 荞݋֎~
        'Md.dwIn02 = Apci34w.IRQ_DISABLE     ' 荞݋֎~
        'Md.dwIn09 = Apci34w.IRQ_DISABLE     ' 荞݋֎~
        'Md.dwIn10 = Apci34w.IRQ_DISABLE     ' 荞݋֎~
        'If P34w.IrqMode(wLogSlot, Md) = False Then
        '    ErrorMessage(wLogSlot)
        '    Exit Sub
        'End If
        '-------------------------------------------------
        ' aPCI-P34̎gpJ
        '-------------------------------------------------
        If P34w.Close(wLogSlot) = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If
        ResultMessage("Closed")
        Me.Close()
    End Sub

    '============================================================================
    '    ʂ\
    '============================================================================
    Private Sub ResultMessage(ByVal lpszbuf As String)
        MsgBox(lpszbuf, MsgBoxStyle.OKOnly + MsgBoxStyle.Information, Me.Text)
    End Sub

    '============================================================================
    '    G[bZ[W\
    '============================================================================
    Private Sub ErrorMessage(ByVal wLogSlot As Short)
        Dim dwRes As Integer
        Dim szBuf As String

        dwRes = P34w.GetLastError(wLogSlot)
        dwRes = P34w.GetLastError(wLogSlot)
        Select case dwRes
            case Apci34w.ERR_WRAPDLL, Apci34w.ERR_SYSTEM
                dwRes = System.Runtime.InteropServices.Marshal.GetLastWin32Error()
                szBuf = String.Concat("System error", vbCrLf, vbCrLf, _
                                        String.Format("Error code: &H{0:x8}", dwRes))
            case Else
                szBuf = String.Concat("aPCI-P34 error", vbCrLf, vbCrLf, _
                                        String.Format("Error code: &H{0:x8}", dwRes))
        End Select
        MsgBox(szBuf, MsgBoxStyle.OKOnly + MsgBoxStyle.Critical, Me.Text)
    End Sub


End Class
