/*============================================================================
//	apci34s.h
//
//	aPCI-P34
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	̿ɂׯ߰֐̎gpႪLqĂ܂B
//
//==========================================================================*/

#pragma once

#include "windows.h"
#include "Apci34w.h"

namespace SampleP34 {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	/// <summary>
	/// Form1 ̊Tv
	///
	/// x: ̃NX̖OύXꍇÃNXˑ邷ׂĂ .resx t@CɊ֘Atꂽ
	///          }l[W \[X RpC c[ɑ΂ 'Resource File Name' vpeB
	///          ύXKv܂B̕ύXsȂƁA
	///          fUCiƁÃtH[Ɋ֘Atꂽ[JCYς݃\[XƂA
	///          ݂ɗpłȂȂ܂B
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{
	public:
		Form1(void)
		{
			InitializeComponent();
			//
			//TODO: ɃRXgN^ R[hǉ܂
			//
		}

	protected:
		/// <summary>
		/// gp̃\[XׂăN[Abv܂B
		/// </summary>
		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}

	private:
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		System::ComponentModel::Container ^components;

		static Apci34w *P34w;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		void InitializeComponent(void)
		{
			this->SuspendLayout();
			// 
			// Form1
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 12);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(292, 266);
			this->Name = L"Form1";
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
			this->Text = L"aPCI-P34 Sample";
			this->Load += gcnew System::EventHandler(this, &Form1::Form1_Load);
			this->ResumeLayout(false);

		}
#pragma endregion
		private: System::Void Form1_Load(System::Object^  sender, System::EventArgs^  e)
		{
			short wLogSlot;				// ޲̘_ۯĔԍi[
			Apci34w::Resource* Ri;		// ؿ
			Apci34w::Mode* Md;
			int dwDllVer, dwDrvVer;
			int dwSwVal;				// ۰ذ̒l
			int i;
			Byte cbDat;
			bool bResult;				// 
			String^ szBuf;

			// 
			P34w = new Apci34w();
			Md   = new Apci34w::Mode;
			Ri   = new Apci34w::Resource;

			Ri->dwNumMemWindows = 0;
			for (i = 0; i< Apci34w::MAX_MEM; i++) {
				Ri->dwMemBase[i] = 0;
				Ri->dwMemLength[i] = 0;
				Ri->dwMemAttrib[i] = 0;
			}
			Ri->dwNumIOPorts = 0;
			for (i = 0; i< Apci34w::MAX_IO; i++) {
				Ri->dwIOPortBase[i] = 0;
				Ri->dwIOPortLength[i] = 0;
			}
			Ri->dwNumIRQs = 0;
			for (i = 0; i < Apci34w::MAX_IRQ; i++) {
				Ri->dwIRQRegisters[i] = 0;
				Ri->dwIRQAttrib[i] = 0;
			}
			Ri->dwNumDMAs = 0;
			for (i = 0; i < Apci34w::MAX_DMA; i++) {
				Ri->dwDMALst[i] = 0;
				Ri->dwDMAAttrib[i] = 0;
			}
			for (i = 0; i < Apci34w::MAX_RSV; i++)
				Ri->dwReserved1[i] = 0;

			/*-----------------------------------------------------------------------*/
			// ްޮݔԍ\
			// aPCI-34 DLL,ײްްޮݔԍ擾
			if (P34w->GetVersion(&dwDllVer, &dwDrvVer) == false) {
				ErrorMessage(Apci34w::SLOT_AUTO);
				return;
			}
			szBuf = String::Concat("GetVersion\n",
									String::Format("DLL Version\t: {0:x8}\n", dwDllVer),
									String::Format("DRV Version\t: {0:x8}",   dwDrvVer));
			ResultMessage(szBuf);

			/*-----------------------------------------------------------------------*/
			// aPCI-34̎gp錾
			wLogSlot = Apci34w::SLOT_AUTO;	// gp޲T܂
			bResult = P34w->Create(&wLogSlot, NULL, 0, NULL);	// ꍇA̎޲̘_ۯĔԍi[܂
			if (bResult == false) {			// ޲܂B
				ErrorMessage(Apci34w::SLOT_AUTO);
				return;
			}
			szBuf = String::Concat("Created\n\n",
									String::Format("LogSlot: {0:d}", wLogSlot));
			ResultMessage(szBuf);

			/*-----------------------------------------------------------------------*/
			// ؿ۰ذ̒l擾
			if (P34w->GetResource(wLogSlot, Ri) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			if (P34w->GetSwitchValue(wLogSlot, &dwSwVal) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			szBuf = String::Concat(String::Format("IO Base Address  \t: {0:x4}h - {1:x4}h\n",
													Ri->dwIOPortBase[1],
													Ri->dwIOPortBase[1] + Ri->dwIOPortLength[1] - 1),
									String::Format("IRQ         \t\t: {0:d}\n",
													Ri->dwIRQRegisters[0]),
									String::Format("Switch      \t: {0:x}h",
													dwSwVal));
			ResultMessage(szBuf);

			/*-----------------------------------------------------------------------*/
			// IN01/IN02/IN09/IN10 ̊荞ݐݒ
			Md->dwIn01 = Apci34w::IRQ_DISABLE;			// 荞݋֎~
			Md->dwIn02 = Apci34w::IRQ_DISABLE;			// 荞݋֎~
			Md->dwIn09 = Apci34w::IRQ_DISABLE;			// 荞݋֎~
			Md->dwIn10 = Apci34w::IRQ_DISABLE;			// 荞݋֎~
			if (P34w->IrqMode(wLogSlot, Md) == false) {
				ErrorMessage(wLogSlot);
				return;
			}

			/*-----------------------------------------------------------------------*/
			// Port 1 ɔCӂްo
			cbDat = 0xaa;
			if (P34w->OutPort(wLogSlot, Apci34w::PORT_1, cbDat) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			szBuf = String::Concat("Port 1 փf[^o\n",
									String::Format("Port 1 Out Data: {0:x2}h", cbDat));
			ResultMessage(szBuf);

			/*-----------------------------------------------------------------------*/
			// Port 1 ްǂݍ
			cbDat = 0x00;
			if (P34w->InPort(wLogSlot, Apci34w::PORT_1, &cbDat) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			szBuf = String::Concat("Port 1 f[^\n",
									String::Format("Port 1 In Data: {0:x2}h", cbDat));
			ResultMessage(szBuf);

			/*-----------------------------------------------------------------------*/
			// IN01/IN02/IN09/IN10 ̊荞ݐݒ
			//Md->dwIn01 = Apci34w::IRQ_DISABLE;			// 荞݋֎~
			//Md->dwIn02 = Apci34w::IRQ_DISABLE;			// 荞݋֎~
			//Md->dwIn09 = Apci34w::IRQ_DISABLE;			// 荞݋֎~
			//Md->dwIn10 = Apci34w::IRQ_DISABLE;			// 荞݋֎~
			//if (P34w->IrqMode(wLogSlot, Md) == false) {
			//	ErrorMessage(wLogSlot);
			//	return;
			//}

			/*-----------------------------------------------------------------------*/
			// aPCI-34̎gpJ
			if (P34w->Close(wLogSlot) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			ResultMessage("Closed");
			this->Close();
		}

 		// ʂ\
		private: void ResultMessage(String^ pszbuf)
		{
				MessageBox::Show(pszbuf, this->Text,
									MessageBoxButtons::OK, MessageBoxIcon::Information);
		}

		// װүނ\
		private: void ErrorMessage(short wLogSlot)
		{
			int dwRes = P34w->GetLastError(wLogSlot);
			String^ szbuf;

			switch (dwRes) {
				case Apci34w::ERR_WRAPDLL:
				case Apci34w::ERR_SYSTEM:
					dwRes = System::Runtime::InteropServices::Marshal::GetLastWin32Error();
					szbuf = String::Concat("System error\n\n",
											String::Format("Error code: {0:x8}h", dwRes));
					break;
				default:
					szbuf = String::Concat("aPCI-P34 error\n\n",
											String::Format("Error code: {0:x8}h", dwRes));
					break;
			}
			MessageBox::Show(szbuf, "aPCI-P34 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Stop);
		}

	};
}

