//============================================================================
//	apci34w.pas
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 2004/03/11
//
//============================================================================

unit apci34w;

interface

uses
	Windows;

//-------------------------------------
// װޒ萔
//-------------------------------------
const
	APCI34_SUCCESS							= 0;	  // I
	APCI34_ERR_SYSTEM						= 1;	  // GetLastError sĂ
	APCI34_ERR_NO_DEVICE				= 2;	  // gp\޲Ȃ
	APCI34_ERR_IN_USE						= 3;	  // w肳ꂽ޲͎gp
	APCI34_ERR_INVALID_SLOT			= 4;	  // Ș_ۯĔԍw肵
	APCI34_ERR_RESOURCE					= 5;	  // ؿװ
	APCI34_ERR_INVALID_PORT			= 6;	  // ߰Ăv
	APCI34_ERR_INVALID_ARGUMENT	= 7;	  // Ȉv
	APCI34_ERR_NO_CREATE				= 8;	  // ޲شĂĂ܂
	APCI34_ERR_WRAPDLL					= Dword(-1);		// ׯ߰֐װ
//-------------------------------------
// ߰Ĕԍ萔
//-------------------------------------
	APCI34_PORT_1 = 0;
	APCI34_PORT_2 = 1;
	APCI34_PORT_3 = 2;
	APCI34_PORT_4 = 3;
//-------------------------------------
// IN01/IN02/IN09/IN10̊荞ݒ萔
//-------------------------------------
  APCI34_IRQ_ACTIVE_LOW   = 0;        // Active Low
  APCI34_IRQ_ACTIVE_HIGH  = 1;        // Active High
  APCI34_IRQ_DISABLE      = 2;        // 荞݋֎~
//-------------------------------------
// ̑萔
//-------------------------------------
	APCI34_DLL_NAME 	= 'apci34.dll';	  // DLĻٖ
	APCI34_MAX_PORTS	= 4;							// ߰Đ
	APCI34_MAX_SLOTS	= 16;							// őۯĐ
	APCI34_DEVICE_ID	= $136c9134;			// ޲ID
	APCI34_SLOT_AUTO	= $ffff;					// AutoSlotl
//-------------------------------------
// bZ[W
// Apci34Create  uWMBase ɐݒ肵lɂāAWM_APCI34_01 Ȃǂ
// ItZbglbZ[Wo܂B
//-------------------------------------
{$IFNDEF WM_APCI34_IN01}
const
  WM_APCI34_IN01  = 0;		            // IRQ0(IN01)
  WM_APCI34_IN02	= 1;		            // IRQ1(IN02)
  WM_APCI34_IN09	= 2;		            // IRQ2(IN09)
  WM_APCI34_IN10	=	3;		            // IRQ3(IN10)
  WM_APCI34_TIMER	=	4;		            // Timer
{$ENDIF}	{ WM_APCI34_IN01 }
//-------------------------------------
// ؿ\
//-------------------------------------
	APCI34_MAX_MEM	=	 9;
	APCI34_MAX_IO	  = 20;
	APCI34_MAX_IRQ	=	 7;
	APCI34_MAX_DMA	=	 7;

type
	TAPCI34RESOURCE = record
		dwNumMemWindows:																DWORD;	// س޳(gp)
		dwMemBase:			array [1 .. APCI34_MAX_MEM] of	DWORD;	// س޳ްڽ(gp)
		dwMemLength:		array [1 .. APCI34_MAX_MEM] of	DWORD;	// س޳(gp)
		dwMemAttrib:		array [1 .. APCI34_MAX_MEM] of	DWORD;	// س޳(gp)
		dwNumIOPorts:																		DWORD;	// I/O߰Đ
		dwIOPortBase:		array [1 .. APCI34_MAX_IO] of	  DWORD;	// I/O߰ްڽ
		dwIOPortLength: array [1 .. APCI34_MAX_IO] of	  DWORD;	// I/O߰Ē
		dwNumIRQs:																			DWORD;	// IRQ(gp)
		dwIRQRegisters: array [1 .. APCI34_MAX_IRQ] of	DWORD;	// IRQؽ(gp)
		dwIRQAttrib:		array [1 .. APCI34_MAX_IRQ] of	DWORD;	// IRQؽ(gp)
		dwNumDMAs:																			DWORD;	// DMAِ(gp)
		dwDMALst:				array [1 .. APCI34_MAX_DMA] of	DWORD;	// DMAؽ(gp)
		dwDMAAttrib:		array [1 .. APCI34_MAX_DMA] of	DWORD;	// DMAّؽ(gp)
		dwReserved1:		array [1 .. 3] of								DWORD;	// \(gp)
	end;

PAPCI34R = ^TAPCI34RESOURCE;

//-------------------------------------
// 荞݃f[^\
//-------------------------------------
type
  TAPCI34MODE = record
    dwIn01: DWORD;     { IN01̐ݒ (0:Active Low, 1:Active High, 2:荞݋֎~) }
    dwIn02: DWORD;     { IN02̐ݒ (0:Active Low, 1:Active High, 2:荞݋֎~) }
    dwIn09: DWORD;     { IN09̐ݒ (0:Active Low, 1:Active High, 2:荞݋֎~) }
    dwIn10: DWORD;     { IN10̐ݒ (0:Active Low, 1:Active High, 2:荞݋֎~) }
  end;

PAPCI34M = ^TAPCI34MODE;

//-------------------------------------
// J֐
//-------------------------------------
// DLL ۰
function Apci34wDllOpen: Boolean;
// DLL ۰
function Apci34wDllClose: Boolean;
// aPCI-P34 DLL,޲ײްްޮݔԍ擾
function Apci34wGetVersion(var pdwDllVersion:DWORD; var pdwDriverVersion:DWORD): Boolean;
// CӂaPCI-P34̎gp錾
function Apci34wCreate(var pwLogSlot:WORD; hwnd:THandle; uWMBase:UInt; var pvInitArg): Boolean;
// CӂaPCI-P34̎gpJ
function Apci34wClose(wLogSlot:WORD): Boolean;
// ؿ擾
function Apci34wGetResource(wLogSlot:WORD; var pResInfo:TAPCI34RESOURCE): Boolean;
// ۰ذ̒l擾
function Apci34wGetSwitchValue(wLogSlot:WORD; var pdwSwitchValue:DWORD): Boolean;
// Cӂ߰Ăް
function Apci34wInPort(wLogSlot:WORD; dwLogPort:DWORD; var pbInValue:BYTE): Boolean;
// Cӂ߰Ăްo
function Apci34wOutPort(wLogSlot:WORD; dwLogPort:DWORD; bOutValue:BYTE): Boolean;
// IN01/IN02/IN09/IN10 ̊荞ݐݒ
function Apci34wIrqMode(wLogSlot:WORD; pcmode: PAPCI34M): Boolean;
// ^C}[荞݂Lɂ
function Apci34wEnableTimer(wLogSlot:WORD; dwTimerCount:DWORD; dwPlescaler:DWORD): Boolean;
// ^C}[荞݂𖳌ɂ
function Apci34wDisableTimer(wLogSlot:WORD): Boolean;
// aPCI-P34̴װ
function Apci34wGetLastError(wLogSlot:WORD): DWORD;

//-------------------------------------
// (STATIC)ϐȂ
//-------------------------------------
implementation

type
	TApci34GetVersion = function(var pdwDllVersion:DWORD; var pdwDriverVersion:DWORD): BOOL; stdcall;
	TApci34Create = function(var pwLogSlot:WORD; hwnd:THandle; uWMBase:UInt; var pvInitArg): BOOL; stdcall;
	TApci34Close = function(wLogSlot:WORD): BOOL; stdcall;
	TApci34GetResource = function(wLogSlot:WORD; var pres:TAPCI34RESOURCE): BOOL; stdcall;
	TApci34GetSwitchValue = function(wLogSlot:WORD; var pdwSwitchValue:DWORD): BOOL; stdcall;
	TApci34InPort = function(wLogSlot:WORD; dwLogPort:DWORD; var pbInValue:BYTE): BOOL; stdcall;
	TApci34OutPort = function(wLogSlot:WORD; dwLogPort:DWORD; bOutValue:BYTE): BOOL; stdcall;
  TApci34IrqMode = function(wLogSlot:WORD; pcmode:PAPCI34M): BOOL; stdcall;
  TApci34EnableTimer = function(wLogSlot:WORD; dwTimerCount:DWORD; dwPlescaler:DWORD): BOOL; stdcall;
  TApci34DisableTimer = function(wLogSlot:WORD): BOOL; stdcall;
	TApci34GetLastError = function(wLogSlot:WORD): DWORD; stdcall;

function Apci34wGetDllExportFunc: Boolean; forward;

{$J+}	// ^t萔̕ύX\߲׎w
const
	hDLL: THandle = 0;
{$J-}


// DLL ߰Ċ֐ڽ̊i[ϐ
var
	pApci34GetVersion: TApci34GetVersion;
	pApci34Create: TApci34Create;
	pApci34Close: TApci34Close;
	pApci34GetResource: TApci34GetResource;
	pApci34GetSwitchValue: TApci34GetSwitchValue;
	pApci34InPort: TApci34InPort;
	pApci34OutPort: TApci34OutPort;
	pApci34IrqMode: TApci34IrqMode;
	pApci34EnableTimer: TApci34EnableTimer;
	pApci34DisableTimer: TApci34DisableTimer;

	pApci34GetLastError: TApci34GetLastError;

//============================================================================
// 		apci34.dll۰(۰ގʹװƂ)
// 		
// ߂l  True
//				s False
//============================================================================
function Apci34wDllOpen: Boolean;
begin
	Result := False;

	if hDLL <> 0 then Exit;

	hDLL := LoadLibrary(APCI34_DLL_NAME);
  if hDLL = 0 then exit;

	if Apci34wGetDllExportFunc = False then
  begin
    Apci34wDllClose;			// DLL֐擾ɎŝDLL۰
		Exit;
	end;

  Result := True;
end;
//============================================================================
// 		apci34.dll۰(۰ގʹװƂ)
// 		
// ߂l  True
//				s False
//============================================================================
function Apci34wDllClose: Boolean;
begin
	Result := True;

	if hDLL = 0 then Exit;

	if FreeLibrary(hDLL) = True then hDLL := 0
	else Result := False;
end;
//============================================================================
// 		aPCI-P34 DLL,޲ײްްޮݔԍ擾
// 		pdwDllVersion			DLLްޮݔԍi[̈ւ߲
//				pdwDriverVersion	޲ײްްޮݔԍi[̈ւ߲
// ߂l  True
//				s False
//============================================================================
function Apci34wGetVersion(var pdwDllVersion:DWORD; var pdwDriverVersion:DWORD): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci34GetVersion(pdwDllVersion, pdwDriverVersion);
end;
//============================================================================
// 		aPCI-P34̔Cӂ޲̎gp錾
// 		pwLogSlot   gp޲̘_ۯĔԍi[߲
//        hWnd        bZ[W𑗂EChEnh
//        uWMBase     ƂȂ郁bZ[WID
//        pvInitArg   gp
// ߂l  True
//				s False
//============================================================================
function Apci34wCreate(var pwLogSlot:WORD; hwnd:THandle; uWMBase:UInt; var pvInitArg): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;
  Result := pApci34Create(pwLogSlot, hWnd, uWMBase, pvInitArg);
end;
//============================================================================
// 		aPCI-P34̔Cӂ޲̎gpJ
// 		wLogSlot ޲̘_ۯĔԍ
// ߂l  True
//				s False
//============================================================================
function Apci34wClose(wLogSlot:WORD): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci34Close(wLogSlot);
end;
//============================================================================
// 		w޲ؿ擾
// 		wLogSlot	ؿ擾޲̘_ۯĔԍ
//				pResInfo	ؿi[\߲̂
// ߂l  True
//				s False
//============================================================================
function Apci34wGetResource(wLogSlot:WORD; var pResInfo:TAPCI34RESOURCE): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci34GetResource(wLogSlot, pResInfo);
end;
//============================================================================
// 		۰ذ̒l擾
// 		wLogSlot				۰ذ̒l擾޲̘_ۯĔԍ
// 				pdwSwitchValue	۰ذ̒li[̈ւ߲
// ߂l  True
//				s False
//============================================================================
function Apci34wGetSwitchValue(wLogSlot:WORD; var pdwSwitchValue:DWORD): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci34GetSwitchValue(wLogSlot, pdwSwitchValue);
end;
//============================================================================
// 		Cӂ߰Ăް
// 		wLogSlot	͂޲̘_ۯĔԍ
//				dwLogPort	͂_߰
//				pbInValue ްi[̈ւ߲
// ߂l  True
//				s False
//============================================================================
function Apci34wInPort(wLogSlot:WORD; dwLogPort:DWORD; var pbInValue:BYTE): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci34InPort(wLogSlot, dwLogPort, pbInValue);
end;
//============================================================================
// 		Cӂ߰Ăްo
// 		wLogSlot	o͂޲̘_ۯĔԍ
//				dwLogPort	o͂_߰
//				bOutValue o͂ް
// ߂l  True
//				s False
//============================================================================
function Apci34wOutPort(wLogSlot:WORD; dwLogPort:DWORD; bOutValue:BYTE): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci34OutPort(wLogSlot, dwLogPort, bOutValue);
end;
//============================================================================
// 		IN01/IN02/IN09/IN10 ̊荞ݐݒ
// 		wLogSlot	o͂޲̘_ۯĔԍ
//				pcmode    荞݃f[^
// ߂l  True
//				s False
//============================================================================
function Apci34wIrqMode(wLogSlot:WORD; pcmode:PAPCI34M): Boolean;
begin
	Result := False;

	if hDLL = 0 then exit;

  Result := pApci34IrqMode(wLogSlot, pcmode);
end;
//============================================================================
// 		^C}[荞݂Lɂ
// 		wLogSlot	    o͂޲̘_ۯĔԍ
//        dwTimerCount  ^C}[̃JE^
//        dwPlescaler   ^C}[̃NbNg
// ߂l  True
//				s False
//============================================================================
function Apci34wEnableTimer(wLogSlot:WORD; dwTimerCount:DWORD; dwPlescaler:DWORD): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci34EnableTimer(wLogSlot, dwTimerCount, dwPlescaler);
end;
//============================================================================
// 		^C}[荞݂𖳌ɂ
// 		wLogSlot	    o͂޲̘_ۯĔԍ
// ߂l  True
//				s False
//============================================================================
function Apci34wDisableTimer(wLogSlot:WORD): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci34DisableTimer(wLogSlot);
end;
//============================================================================
// 		aPCI-P34̴װ
// 		wLogSlot	װ޲̘_ۯĔԍ
// ߂l װ
//============================================================================
function Apci34wGetLastError(wLogSlot:WORD): DWORD;
begin
  Result := APCI34_ERR_WRAPDLL;

	if hDLL = 0 then Exit;

	Result := pApci34GetLastError(wLogSlot);
end;
//---------------------------------------------------------------------------
// 	  DLL߰Ċ֐ڽ̎擾
// 	  
// ߂l  True
//		  	s False
//---------------------------------------------------------------------------
function Apci34wGetDllExportFunc: Boolean;
begin
	Result := False;

	// Apci34GetVersion ̱ڽ擾
	pApci34GetVersion := GetProcAddress(hDLL, 'Apci34GetVersion');
	if @pApci34GetVersion = nil then Exit;

	// Apci34Create ̱ڽ擾
	pApci34Create := GetProcAddress(hDLL, 'Apci34Create');
	if @pApci34Create = nil then Exit;

	// Apci34Close ̱ڽ擾
	pApci34Close := GetProcAddress(hDLL, 'Apci34Close');
	if @pApci34Close = nil then Exit;

	// Apci34GetResource ̱ڽ擾
	pApci34GetResource := GetProcAddress(hDLL, 'Apci34GetResource');
	if @pApci34GetResource = nil then Exit;

	// Apci34GetSwitchValue ̱ڽ擾
	pApci34GetSwitchValue := GetProcAddress(hDLL, 'Apci34GetSwitchValue');
	if @pApci34GetSwitchValue = nil then Exit;

	// Apci34InPort ̱ڽ擾
	pApci34InPort := GetProcAddress(hDLL, 'Apci34InPort');
	if @pApci34InPort = nil then Exit;

	// Apci34OutPort ̱ڽ擾
	pApci34OutPort := GetProcAddress(hDLL, 'Apci34OutPort');
	if @pApci34OutPort = nil then Exit;

	// Apci34IrqMode ̱ڽ擾
	pApci34IrqMode := GetProcAddress(hDLL, 'Apci34IrqMode');
	if @pApci34IrqMode = nil then Exit;

	// Apci34EnableTimer ̱ڽ擾
	pApci34EnableTimer := GetProcAddress(hDLL, 'Apci34EnableTimer');
	if @pApci34EnableTimer = nil then Exit;

	// Apci34DisableTimer ̱ڽ擾
	pApci34DisableTimer := GetProcAddress(hDLL, 'Apci34DisableTimer');
	if @pApci34DisableTimer = nil then Exit;

	// Apci34GetLastError ̱ڽ擾
	pApci34GetLastError := GetProcAddress(hDLL, 'Apci34GetLastError');
	if @pApci34GetLastError = nil then Exit;


	// SĂ DLL ߰Ċ֐ڽ擾nj
	Result := True;
end;

end.

