Attribute VB_Name = "DLLDef"
'-----------------------------------------------------------------------
'       APCI-P34 Win32 API.
'-----------------------------------------------------------------------

Option Explicit

'-------------------------------------
' װޒ萔
'-------------------------------------
Global Const APCI34_SUCCESS = 0               ' ُȂ
Global Const APCI34_ERR_SYSTEM = 1            ' GetLastError sĂ
Global Const APCI34_ERR_NO_DEVICE = 2         ' gp\ȃfoCXȂ
Global Const APCI34_ERR_IN_USE = 3            ' w肳ꂽۯĂ͎gp
Global Const APCI34_ERR_INVALID_SLOT = 4      ' ȁi_jۯĔԍ
Global Const APCI34_ERR_RESOURCE = 5          ' \[XG[
Global Const APCI34_ERR_INVALID_PORT = 6      ' ȃ|[gԍ
Global Const APCI34_ERR_INVALID_ARGUMENT = 7  ' Ȉ
Global Const APCI34_ERR_NO_CREATE = 8         ' foCXNGCgĂ܂
'-------------------------------------
' _߰
'-------------------------------------
Global Const APCI34_PORT_1 = 0
Global Const APCI34_PORT_2 = 1
Global Const APCI34_PORT_3 = 2
Global Const APCI34_PORT_4 = 3
'-------------------------------------
' IN01/IN02/IN09/IN10̊荞ݒ萔
'-------------------------------------
Global Const APCI34_IRQ_ACTIVE_LOW = 0        ' Active Low
Global Const APCI34_IRQ_ACTIVE_HIGH = 1       ' Active High
Global Const APCI34_IRQ_DISABLE = 2           ' 荞݋֎~
'-------------------------------------
' bZ[W
' Apci34Create  uWMBase ɐݒ肵lɂāAWM_APCI34_01 Ȃǂ
' ItZbglbZ[Wo܂B
'-------------------------------------
Global Const WM_APCI34_IN01 = 0                                 ' IRQ0(IN01)
Global Const WM_APCI34_IN02 = 1                                         ' IRQ1(IN02)
Global Const WM_APCI34_IN09 = 2                                         ' IRQ2(IN09)
Global Const WM_APCI34_IN10 = 3                                         ' IRQ3(IN10)
Global Const WM_APCI34_TIMER = 4                                ' Timer
'-------------------------------------
' ̑萔
'-------------------------------------
Global Const APCI34_MAX_SLOTS = 16            ' T|[g{[h
Global Const APCI34_MAX_PORTS = 4             ' ANZX\ȃ|[g
Global Const APCI34_SLOT_AUTO = &HFFFF        '
'-------------------------------------
' ؿ\
'-------------------------------------
Global Const APCI34_MAX_MEM = 9
Global Const APCI34_MAX_IO = 20
Global Const APCI34_MAX_IRQ = 7
Global Const APCI34_MAX_DMA = 7

Type APCI34RESOURCE
    dwNumMemWindows As Long                        ' س޳       gp
    dwMemBase(1 To APCI34_MAX_MEM) As Long         ' س޳ްڽgp
    dwMemLength(1 To APCI34_MAX_MEM) As Long       ' س޳       gp
    dwMemAttrib(1 To APCI34_MAX_MEM) As Long       ' س޳     gp
    dwNumIOPorts As Long                           ' I/O߰Đ
    dwIOPortBase(1 To APCI34_MAX_IO) As Long       ' I/O߰ްڽ
    dwIOPortLength(1 To APCI34_MAX_IO) As Long     ' I/O߰Ē
    dwNumIRQs As Long                              ' IRQ             gp
    dwIRQRegisters(1 To APCI34_MAX_IRQ) As Long    ' IRQؽ            gp
    dwIRQAttrib(1 To APCI34_MAX_IRQ) As Long       ' IRQؽ        gp
    dwNumDMAs As Long                              ' DMAِ         gp
    dwDMALst(1 To APCI34_MAX_DMA) As Long          ' DMAؽ        gp
    dwDMAAttrib(1 To APCI34_MAX_DMA) As Long       ' DMAّؽ    gp
    dwReserved1(1 To 3) As Long                    ' \              gp
End Type
'-------------------------------------
' 荞݃f[^\
'-------------------------------------
Type APCI34MODE
    dwIn01 As Long          ' IN01̐ݒ (0:Active Low, 1:Active High, 2:荞݋֎~)
    dwIn02 As Long          ' IN02̐ݒ (0:Active Low, 1:Active High, 2:荞݋֎~)
    dwIn09 As Long          ' IN09̐ݒ (0:Active Low, 1:Active High, 2:荞݋֎~)
    dwIn10 As Long          ' IN10̐ݒ (0:Active Low, 1:Active High, 2:荞݋֎~)
End Type
'-------------------------------------
' J֐
'-------------------------------------
Declare Function Apci34GetVersion Lib "apci34" (pdwDllVersion As Long, pdwDriverVersion As Long) As Long
Declare Function Apci34Create Lib "apci34" (ByRef pwLogSlot As Integer, ByVal hWnd As Long, ByVal uWMBase As Long, ByRef pvInitArg As Long) As Long
Declare Function Apci34Close Lib "apci34" (ByVal wLogSlot As Integer) As Long
Declare Function Apci34GetResource Lib "apci34" (ByVal wLogSlot As Integer, pres As APCI34RESOURCE) As Long
Declare Function Apci34GetSwitchValue Lib "apci34" (ByVal wLogSlot As Integer, pdwSwitchValue As Long) As Long
Declare Function Apci34InPort Lib "apci34" (ByVal wLogSlot As Integer, ByVal dwLogPort As Long, pbInValue As Byte) As Long
Declare Function Apci34OutPort Lib "apci34" (ByVal wLogSlot As Integer, ByVal dwLogPort As Long, ByVal bOutValue As Byte) As Long
Declare Function Apci34IrqMode Lib "apci34" (ByVal wLogSlot As Integer, ByRef pcmode As APCI34MODE) As Long
Declare Function Apci34EnableTimer Lib "apci34" (ByVal wLogSlot As Integer, ByVal dwTimerCount As Long, ByVal dwPlescaler As Long) As Long
Declare Function Apci34DisableTimer Lib "apci34" (ByVal wLogSlot As Integer) As Long
Declare Function Apci34GetLastError Lib "apci34" (ByVal wLogSlot As Integer) As Long

