Attribute VB_Name = "Sample"
'============================================================================
'
'  aPCI-P34
'
'  Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'
'  Date 2004/03/11
'
'   ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
'
'============================================================================
Option Explicit

Private Const szTitle = "Sample"
Private Const szP34 = "aPCI-P34"
Private Declare Function GetLastError Lib "kernel32" () As Long

'============================================================================
'   ۸т̊Jn
'============================================================================
Sub Main()

    Dim wLogSlot As Integer     ' ޲̘_ۯĔԍi[
    Dim Ri As APCI34RESOURCE    ' ؿ
    Dim dwDllVer As Long, dwDriverVer As Long
    Dim dwSwVal As Long         ' ۰ذ̒l
    Dim cbDat As Byte
    Dim bResult As Boolean      ' 
    Dim szBuf As String
    Dim md As APCI34MODE
    '-------------------------------------------------
    ' apci34.dll ̎gp錾
    '-------------------------------------------------
    If Apci34wDllOpen() = False Then
        ErrorMessage (APCI34_SLOT_AUTO)
        Exit Sub                   ' apci34.dll ۰ނɎs܂
    End If
    '-------------------------------------------------
    ' ްޮݔԍ\
    ' aPCI-P34 DLL,ײްްޮݔԍ擾
    '-------------------------------------------------
    If Apci34wGetVersion(dwDllVer, dwDriverVer) = False Then
        ErrorMessage (APCI34_SLOT_AUTO)
        Exit Sub
    End If
    
    szBuf = "GetVersion" + Chr(10) + _
                "DLL    Version" + Chr(9) + ": &H" + Right("00000000" + Hex(dwDllVer), 8) + Chr(10) + _
                "Driver Version" + Chr(9) + ": &H" + Right("00000000" + Hex(dwDriverVer), 8)
    ResultMessage (szBuf)
    '-------------------------------------------------
    ' aPCI-P34̎gp錾
    '-------------------------------------------------
    wLogSlot = APCI34_SLOT_AUTO           ' gp޲T܂B
    bResult = Apci34wCreate(wLogSlot, 0, 0, 0)     ' ꍇA̎޲̘_ۯĔԍi[܂B
    If bResult = False Then                ' ޲܂B
        ErrorMessage (APCI34_SLOT_AUTO)
        Exit Sub
    End If
    
    szBuf = "aPCI-P34 Created" + Chr(10) + Chr(10) + _
                "LogSlot: " + Str(wLogSlot)
    ResultMessage (szBuf)
    '-------------------------------------------------
    ' ؿ۰ذ̒l擾
    '-------------------------------------------------
    If Apci34wGetResource(wLogSlot, Ri) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    If Apci34wGetSwitchValue(wLogSlot, dwSwVal) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    szBuf = "Board Name  " + Chr(9) + ": " + szP34 + Chr(10) + _
            "IO Base Address " + Chr(9) + ": &H" + Hex(Ri.dwIOPortBase(2)) + _
            " - &H" + Hex(Ri.dwIOPortBase(2) + Ri.dwIOPortLength(2) - 1) + Chr(10) + _
            "IRQ             " + Chr(9) + ": " + Str(Ri.dwIRQRegisters(1)) + Chr(10) + _
            "Switch          " + Chr(9) + ": &H" + Hex(dwSwVal)
    ResultMessage (szBuf)
    '-------------------------------------------------
    ' IN01/IN02/IN09/IN10 ̊荞ݐݒ
    '-------------------------------------------------
    md.dwIn01 = APCI34_IRQ_DISABLE      ' 荞݋֎~
    md.dwIn02 = APCI34_IRQ_DISABLE      ' 荞݋֎~
    md.dwIn09 = APCI34_IRQ_DISABLE      ' 荞݋֎~
    md.dwIn10 = APCI34_IRQ_DISABLE      ' 荞݋֎~
    If Apci34wIrqMode(wLogSlot, md) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    '-------------------------------------------------
    ' Port 1 ɔCӂްo
    '-------------------------------------------------
    cbDat = &HAA
    If Apci34wOutPort(wLogSlot, APCI34_PORT_1, cbDat) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    szBuf = "Port 1 փf[^o" + Chr(10) + _
                "Port 1 Out Data: &H" + Hex(cbDat)
    ResultMessage (szBuf)
    '-------------------------------------------------
    ' Port 1 f[^ǂݍ
    '-------------------------------------------------
    cbDat = &H0
    If Apci34wInPort(wLogSlot, APCI34_PORT_1, cbDat) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    szBuf = "Port 1 f[^" + Chr(10) + _
                "Port 1 In Data: &H" + Hex(cbDat)
    ResultMessage (szBuf)
    '-------------------------------------------------
    ' IN01/IN02/IN09/IN10 ̊荞ݐݒ
    '-------------------------------------------------
    'md.dwIn01 = APCI34_IRQ_DISABLE      ' 荞݋֎~
    'md.dwIn02 = APCI34_IRQ_DISABLE      ' 荞݋֎~
    'md.dwIn09 = APCI34_IRQ_DISABLE      ' 荞݋֎~
    'md.dwIn10 = APCI34_IRQ_DISABLE      ' 荞݋֎~
    'If Apci34wIrqMode(wLogSlot, md) = False Then
    '    ErrorMessage (wLogSlot)
    '    Exit Sub
    'End If
    '-------------------------------------------------
    ' aPCI-P34̎gpJ
    '-------------------------------------------------
    If Apci34wClose(wLogSlot) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    ResultMessage ("aPCI-P34 Closed")
    '-------------------------------------------------
    ' apci34.dll ̎gpJ
    '-------------------------------------------------
    If Apci34wDllClose() = False Then
        MsgBox "DLL ̃A[hɎs܂B", vbOKOnly + vbCritical
        Exit Sub
    End If
    
End Sub
'============================================================================
'    ʂ\
'============================================================================
Private Sub ResultMessage(lpszbuf As String)

    MsgBox lpszbuf, vbOKOnly + vbInformation

End Sub
'============================================================================
'    G[bZ[W\
'============================================================================
Private Sub ErrorMessage(ByVal wLogSlot As Integer)
    Dim dwRes As Long
    Dim szBuf As String

    dwRes = Apci34wGetLastError(wLogSlot)
    Select Case dwRes
        Case APCI34_ERR_SYSTEM
            szBuf = "System error" + Chr(10) + Chr(10) + "Error code: &H" + Hex(GetLastError())
        Case APCI34_ERR_WRAPDLL
            szBuf = "DLL Load error"
        Case Else
            szBuf = "aPCI-P34 error" + Chr(10) + Chr(10) + "Error code: &H" + Hex(dwRes)
    End Select
    MsgBox szBuf, vbOKOnly + vbCritical
    
End Sub

