/*****************************************************************************/
/*	apci34w.h																 */
/*																			 */
/*	aPCI-P34															 */
/*																			 */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									 */
/*																			 */
/*	Date 2004/03/11													 		 */
/*																			 */
/*****************************************************************************/

#ifndef __APCI34W_H__
#define __APCI34W_H__

#include "apci34.h"

#ifdef __cplusplus
extern "C"{
#endif

#define APCI34_DLL_NAME	_T("apci34.dll")		// DLL
#define APCI34_ERR_WRAPDLL	((DWORD)-1)			// ׯ߰֐װ

BOOL Apci34wDllOpen();							// DLL ۰
BOOL Apci34wDllClose();							// DLL ۰
BOOL Apci34wGetVersion(PDWORD pdwDllVersion, PDWORD pdwDriverVersion);	// aPCI-P34 DLL,ײންޮݔԍ擾
BOOL Apci34wCreate(PWORD pwLogSlot, HWND hWnd, UINT uWMBase, PVOID pvInitArg);	// CӂaPCI-P34̎gp錾
BOOL Apci34wClose(WORD wLogSlot);				// CӂaPCI-P34̎gpJ
BOOL Apci34wGetResource(WORD wLogSlot, PAPCI34R pResInfo);			// ؿ擾
BOOL Apci34wGetSwitchValue(WORD wLogSlot, PDWORD pdwSwitchValue);		// ۰ذ̒l擾
BOOL Apci34wInPort(WORD wLogSlot, DWORD dwLogPort, PBYTE pbInValue);	// Cӂ߰Ăް
BOOL Apci34wOutPort(WORD wLogSlot, DWORD dwLogPort, BYTE bOutValue);	// Cӂ߰Ăްo
BOOL Apci34wIrqMode( WORD wLogSlot, PCAPCI34M pcmode );	// IN01/IN02/IN09/IN10 ̊荞ݐݒ
BOOL Apci34wEnableTimer( WORD wLogSlot, DWORD dwTimerCount, DWORD dwPlescaler );	// ϰ荞݂Lɂ
BOOL Apci34wDisableTimer( WORD wLogSlot );		// ϰ荞݂𖳌ɂ
DWORD Apci34wGetLastError(WORD wLogSlot);								// aPCI-P34̴װ

#ifdef __cplusplus
}
#endif

#endif /* __APCI34W_H__ */
